<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Login extends CI_Controller {

	function __construct(){
        /* Session Checking Start*/
        parent::__construct();
        $this->load->model(array('login_model','callback_model'));
        $this->load->library('session');    
    }

    public function index() {
        if ($this->session->userdata('is_loggedin')) 
            redirect(base_url());
        $this->data = array(
            "error" => false,
            "message" => ""
        );
        if($this->input->post()){
            $username=$this->input->post('userName');
            $password=$this->input->post('password');
            $type_array=$this->login_model->get_user_type($username);
            $user_type=$type_array['type'];
            $data = $this->login_model->user_login($username,$password,$user_type);

            if($data){
                if($data->active){
                    if($data->is_new && ($data->type == 1)){
                        $temp = uniqid().uniqid();
                        $this->session->set_userdata('user_key', $temp);
                        redirect(base_url('login/create_password?key='.$temp.'&id='.$data->id));
                    }
                    $user_type="";
                    switch ($data->type) {
                        case 1:
                        $user_type = 'user';
                        break;

                        case 2:
                        $user_type = 'manager';
                        break;

                        case 3:
                        $user_type = 'vp';
                        break;

                        case 4:
                        $user_type = 'director';
                        break;
                        case 5:
                        $user_type = 'admin';
                        break;
                        case 6:
                        $user_type='City_head';
                        break;
                        
                    }
                    if( $user_type == 'user')
                    { 
                        $date1 = date('Y-m-d',strtotime($data->login_time));
                         // echo $date1."   ". date('Y-m-d');die;
                        if($date1!=date('Y-m-d'))
                        {
                            $user_id = $data->id;
                            $this->load->model('login_model');
                            $data1 = array("login_time"=>date('Y-m-d H:i:s'),"todaytimer"=>0);
                            $where1 = array("id"=>$user_id);
                            $bool = $this->login_model->updateWhere($where1,'user',$data1);

                        }
                    }
                    if($user_type=='admin')
                    {
                        $this->data['error'] = true;
                        $this->data['message'] = "Oops! Invalid Username/Password"; 

                    }else{
                        $rand = rand(1000000000000000,10000000000000000);
                        $newdata = array(
                            'user_id' => $data->id,
                            'username'  => $username,
                            'user_email' => $data->email,
                            'user_name' => $data->first_name." ".$data->last_name,
                            'is_loggedin' => TRUE,
                            'last_login' => $data->last_login,
                            'reports_to' => $data->reports_to,
                            'user_type' => $user_type,
                            'user_city_id' => $data->city_id,
                            'user_mobile' => $data->mobile_number,
                            'user_address' => $data->address,
                            'session_id_web' => $rand

                        );

                        $this->session->set_userdata($newdata);
                        $userArray = ['user_id' => $this->session->userdata('user_id')];
                        $usersessionArray = ['session_id'=>$rand];
                        $checkSession = $this->callback_model->getWhere($userArray,'user_web_session');
                        if(empty($checkSession))
                            $this->callback_model->insertRow(['session_id'=>$rand,'user_id' => $this->session->userdata('user_id') ],'user_web_session');
                        else
                            $this->login_model->updateWhere($userArray,'user_web_session',$usersessionArray);
                    //-- permission ----
                        $this->getPermission($this->session->userdata('user_id'));
                    redirect(base_url());
                }
            }
            else{
                $this->data['error'] = true;
                $this->data['message'] = "Your account is inactive, Contact Admin";
            }
        }
        else{
            $this->data['error'] = true;
            $this->data['message'] = "Oops! Invalid Username/Password";
        }
        if ($this->session->flashdata('error')) {
            $this->data['error'] = true;
            $this->data['message'] = "Your session has been expired";
        }

    }
        // echo "<pre>";print_r($this->data);exit;
    $this->load->view('login', $this->data);
}

function admin() {
    if ($this->session->userdata('is_loggedin')) {
        if($this->session->userdata('user_type') == "admin")
            redirect(base_url()."admin");
        else
            redirect(base_url());
    }
    $this->data = array(
        "error" => false,
        "message" => ""
    );
    if($this->input->post()){
        $username=$this->input->post('username');
        $password=$this->input->post('password');
        $data = $this->login_model->admin_login($username,$password);
        if($data){
            if($data->email == 'admin@leads.com' && $data->type == 5) {
                $mData = $this->login_model->getModulesClause();
                $tmpArry = array();
                foreach ($mData as $value) {
                    $tmpArry[] = $value['id'];
                }
                $this->session->set_userdata('permissions', json_encode($tmpArry));
            }
            else 
                $this->getPermission($data->id);

            $newdata = array(
                'user_id' => $data->id,
                'username'  => $username,
                'user_email' => $data->email,
                'user_name' => $data->first_name." ".$data->last_name,
                'is_loggedin' => TRUE,
                'last_login' => $data->last_login,
                'user_type' => 'admin'
            );
            $this->session->set_userdata($newdata);
            redirect(base_url().'admin');
        }
        else{
            $this->data['error'] = true;
            $this->data['message'] = "Oops! Invalid Username/Password";
        }
    }
    $this->load->view('admin/login', $this->data);
}

function logout() {
    $this->session->sess_destroy();
    $this->session->unset_userdata('is_loggedin');
    if($this->session->userdata('user_type') == "admin")
        redirect(base_url().'login/admin');
    else
        redirect(base_url().'login/index');
}

public function create_password() {
    $key = $this->input->get('key');
    if($key == $this->session->userdata('user_key')){
        if($this->input->post()){
            $password = $this->input->post('password');
            $user_id = $this->input->get('id');
            $this->db->update(
                'user',
                array(
                    "password" => md5($password),
                    "is_new" => 0
                ),
                array(
                    "id" => $user_id
                )
            );
            $this->session->unset_userdata('user_key');
            redirect(base_url('login'));
        }
        else{
            $this->load->view('create_password');
        }
    }
    else
        echo "Error";
}

function forget_pass() {
    $email = $this->input->post('email');
    if($this->login_model->forget_password($email))
        echo "success";
    else
        echo "error";
}

function getPermission($userId){
    $fetchData = $this->login_model->getModulePermission(['userId' => $userId]);
    $permission = $fetchData['accessLists'];
    $this->session->set_userdata('permissions', $permission);
}

}
