<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class User_model extends CI_Model {

    public function __construct()
    {
        // Call the CI_Model constructor
        parent::__construct();
    }

    public function all_users($where=""){
    	$this->db->select()
            ->from('user')
            ->order_by('first_name','asc')
            ->order_by('last_name','asc');
            $this->db->where('active',1);
        if($where)
            $this->db->where($where);
        $query=$this->db->get();
        return $query->result();
    }

    public function add_user($data){
        $this->db->insert('user',$data);
        if((in_array($data['type'], array(1,2))) && ($data['email'])){
            $this->load->library('email');
            $config = email_config();

            $this->email->initialize($config);
            $this->email->from("admin@leads.com", "Admin");
            $this->email->to($data['email']);
            $this->email->subject("Welcome to Holding Bricks");
            $this->email->message("Welcome to Holding Bricks CRM System,<br><br>Your user name is ".$data['emp_code']." And password is ".$data['emp_code']." by using them please login to the tool with the following link: <a href=\"http://crm.holdingbricks.com/\" >http://crm.holdingbricks.com/</a> <br><br>Regards Holding Bricks IT team");
            $this->email->send();
        }
    }

    public function all_admins(){        
        $query=$this->db->get_where('user', ['type'=>5, 'emp_code !='=>'admin']);
        return $query->result();
    }

    public function all_vps(){
        $this->db->select('u1.*,department.name as department_name,city.name as city_name,concat(u2.first_name," ",u2.last_name) as reports_to');
        $this->db->from('user as u1');
        $this->db->join('department','department.id=u1.dept_id','LEFT');
        $this->db->join('city','city.id=u1.city_id','LEFT');
        $this->db->join('user as u2','u2.id=u1.reports_to','LEFT');
        $this->db->order_by('u1.id','desc');
        $this->db->where('u1.type','3');
        $query=$this->db->get();
        return $query->result();
    }

    public function all_managers(){
        $this->db->select('u1.*,department.name as department_name,city.name as city_name,concat(u2.first_name," ",u2.last_name) as reports_to');
        $this->db->from('user as u1');
        $this->db->join('department','department.id=u1.dept_id','LEFT');
        $this->db->join('city','city.id=u1.city_id','LEFT');
        $this->db->join('user as u2','u2.id=u1.reports_to','LEFT');
        $this->db->order_by('u1.id','desc');
        $this->db->where('u1.type','2');
        $query=$this->db->get();
        return $query->result();
    }

    public function all_employees(){
        $this->db->select('u1.*,department.name as department_name,city.name as city_name,concat(u2.first_name," ",u2.last_name) as reports_to');
        $this->db->from('user as u1');
        $this->db->join('department','department.id=u1.dept_id','LEFT');
        $this->db->join('city','city.id=u1.city_id','LEFT');
        $this->db->join('user as u2','u2.id=u1.reports_to','LEFT');
        $this->db->order_by('u1.id','desc');
        //$this->db->where('u1.type','1');
        $this->db->where("(u1.type='1' OR u1.type='5')");
        $query=$this->db->get();
        return $query->result();
    }

    public function getEmployeesByLimit($start, $limit){
        $this->db->select('u1.*,department.name as department_name,city.name as city_name,concat(u2.first_name," ",u2.last_name) as reports_to');
        $this->db->from('user as u1');
        $this->db->join('department','department.id=u1.dept_id','LEFT');
        $this->db->join('city','city.id=u1.city_id','LEFT');
        $this->db->join('user as u2','u2.id=u1.reports_to','LEFT');
        $this->db->order_by('u1.id','desc');
        $this->db->where('u1.type','1');

        if($limit!='' ){
           $this->db->limit($limit, $start);
        }
        $query=$this->db->get();
        //echo $this->db->last_query();
        return $query->result();
    }

    public function countEmployees(){
        $this->db->select('u1.*,department.name as department_name,city.name as city_name,concat(u2.first_name," ",u2.last_name) as reports_to');
        $this->db->from('user as u1');
        $this->db->join('department','department.id=u1.dept_id','LEFT');
        $this->db->join('city','city.id=u1.city_id','LEFT');
        $this->db->join('user as u2','u2.id=u1.reports_to','LEFT');
        $this->db->order_by('u1.id','desc');
        $this->db->where('u1.type','1');
        return $this->db->count_all_results();
    }


    public function reset_password($id){
        $this->db->select('emp_code');
        $this->db->from('user');
        $this->db->where('id',$id);
        $query=$this->db->get();
        $user = $query->row();
        $this->db->update(
            'user',
            array(
                'password'=>md5($user->emp_code)
            ),
            array(
                'id'=>$id
            )
        );
    }

    public function get_user_fullname($id){
        $this->db->select('first_name,last_name');
        $this->db->from('user');
        $this->db->where('id',$id);
        $query=$this->db->get();
        $user = $query->row();
        return $user->first_name." ".$user->last_name;
    }

    public function get_usersby_reports_to($id){
        $this->db->select();
        $this->db->from('user');
        $this->db->order_by('id','desc');
        if($this->session->userdata('user_type')=='City_head')
        {
        $ids=array();
        foreach ($this->session->userdata('user_ids') as $id) {
        // echo $id->id;
        $ids[]=$id->id;
        }
        $list_id=implode(',', $ids);
        $this->db->where('id in('.$list_id.')');
        $this->db->where('active',1);
        }
        else
        $this->db->where('reports_to',$id);
        $query=$this->db->get();
        return $query->result();
    }
    public function get_city_users_active()
    {
         $this->db->select('id,first_name,last_name');
        $this->db->from('user');
        $this->db->order_by('id','desc');
        $ids=array();
        foreach ($this->session->userdata('city_user_ids') as $id) {
        // echo $id->id;
        $ids[]=$id->id;
        }
        $list_id=implode(',', $ids);
        $this->db->where('id in('.$list_id.')');
        $this->db->where('active',1);
         $query=$this->db->get();
        return $query->result();
        
    }
    public function get_manager_name($user_id){
        $this->db->select('concat(m.first_name," ",m.last_name) as manager_name');
        $this->db->from('user as u');
        $this->db->join('user as m','u.reports_to = m.id');
        $this->db->where('u.id',$user_id);
        $row = $this->db->get()->row();
        return $row->manager_name;
    }

    public function get_team_members_count($user_id){
        if($this->session->userdata('user_type')=='City_head')
        {
        foreach ($this->session->userdata('user_ids') as $id) {
            // echo $id->id;
            $ids[]=$id->id;
            }
            $list_id=implode(',', $ids);
            $this->db->where("u.id in(".$list_id.")");
        }
        else
        {
        $this->db->where("u.reports_to = $user_id ", NULL, FALSE);
        }
        $this->db->where('active',1);
        $this->db->from('user as u');

        return $this->db->count_all_results();
    }

    public function get_team_members($user_id=false){
        $team = $user_id.",";
        $this->db->select('u.id');
        $this->db->where("u.reports_to = $user_id ", NULL, FALSE);
        $this->db->from('user as u');
        $result = $this->db->get()->result();
        foreach ($result as $key => $value)
            $team .= $value->id.",";
        return $team;
    }

    /*function get_vp_director_admin_emails(){
        $users = $this->db->select('email')
            ->from("user")
            ->where("type in ('3','4','5')")
            ->get()->result();
        
        $exceptions = array("admin@leads.com","admin@leads.com");
        $emails = array();
        foreach ($users as $key => $value) {
          if($value->email)
            if(!in_array($value->email,$exceptions))
            $emails[] = $value->email;
        }
        return $emails;
    }*/
    function getUsersEmails(){
        $users = $this->db->select('email')
            ->from("user")
            ->where("type in ('3','4','5')")
            ->get()->result();
        
        $exceptions = array("admin@leads.com","admin@leads.com", "test@secondsdigital.com");
        $emails = array();
        foreach ($users as $key => $value) {
          if($value->email)
            if(!in_array($value->email,$exceptions))
            $emails[] = $value->email;
        }
        return $emails;
    }
    function get_vp_director_admin_emails(){
        $users = $this->db->select('email')
            ->from("user")
            ->where("type in ('3','4','5')")
            ->get()->result();   
       
        $emails = array();
        foreach ($users as $key => $value) {
          if($value->email)
            $emails[] = $value->email.".test-google-a.com";
        }
        return $emails;
    }
    function get_city_head_email($city_id=null){
        $users = $this->db->select('email')
            ->from("user")
            ->where("city_id",$city_id)
            ->where("type in ('6')")
            ->get()->result();   
       
        $emails = array();
        foreach ($users as $key => $value) {
          if($value->email)
            $emails[] = $value->email;
        }
        return $emails;
    }

    function getUserEmailByClause($clause){
        $clause .= ' AND active=1';
        $this->db->select('email');
        $this->db->where($clause);
        $this->db->from('user');
        $query=$this->db->get();
        $user = $query->result_array();
        return $user;
    }

    public function get_user_data($id){
        $this->db->select('*');
        $this->db->from('user');
        $this->db->where('id',$id);
        $query=$this->db->get();
        $user = $query->row_array();
        return $user;
    }

    public function update_user($data,$id){
        $this->db->where('id',$id);
        $query=$this->db->update('user',$data);
        return ($this->db->affected_rows() == '1')?true:false;
        // echo $this->db->last_query();exit;
    }

    public function get_live_feed_back(){
         $list_id='';
         $ids=array();
        if($this->session->userdata('user_type')=='City_head')
        {
            $ids=array();
          foreach ($this->session->userdata('user_ids') as $id) {
             // echo $id->id;
              $ids[]=$id->id;
          }
        $list_id=implode(',', $ids);
           // $this->db->where("(cb.user_id in($list_id))");
            $this->db->select('first_name, last_name, type, last_login')
            ->from('user')
            ->where_in('type', array('1','2'))
            ->where_in('id', $ids)
            ->where('active', 1)
            ->order_by('last_login','DESC');
        return $this->db->get()->result();
        }
        else
        {
        $this->db->select('first_name, last_name, type, last_login')
            ->from('user')
            ->where_in('type', array('1','2'))
            ->where('date(last_login)',date('Y-m-d'))
            ->where('active', 1)
            ->order_by('last_login','DESC');
        return $this->db->get()->result();
        }
    }
     public function all_city_heads()
    {
        $this->db->select('u1.*,department.name as department_name,city.name as city_name,concat(u2.first_name," ",u2.last_name) as reports_to');
        $this->db->from('user as u1');
        $this->db->join('department','department.id=u1.dept_id','LEFT');
        $this->db->join('city','city.id=u1.city_id','LEFT');
        $this->db->join('user as u2','u2.id=u1.reports_to','LEFT');
        $this->db->order_by('u1.id','desc');
        $this->db->where('u1.type','6');
        $query=$this->db->get();
        return $query->result();
    }
        public function get_city_id($id)
    {
            $this->db->select('city_id');
            $this->db->from('user');
            $this->db->where('id',$id);
            $result= $this->db->get()->result();
          
        return $result;
    }
    public function get_city_user_ids($id='')
    {
            $this->db->select('id');
            $this->db->from('user');
            if($id=='time')
            {
             $this->db->order_by('last_update','desc');
            }
            else
            {
                $this->db->where('city_id',$id); 
            }
            $this->db->where('id!=',$this->session->userdata('user_id'));
            $this->db->where('active',1);
            $result= $this->db->get()->result();
          
             return $result;

    }
    public function get_profile_pic_name($id)
    {
        $this->db->select('profile_pic');
            $this->db->from('user');
            $this->db->where('id',$id);
            $result= $this->db->get()->result();
          
             return $result;

    }
    public function update_profile_pic($id)
    {
        $pic=$id.".jpg";
        $data=array('profile_pic'=>$pic);
        $this->db->where('id',$id);
        $this->db->update('user',$data);
    }
    public function get_user_details($id)
    {
         $this->db->select('*');
            $this->db->from('user');
            $this->db->where($id);
            $result= $this->db->get()->result_array();
          
             return $result;

    }
    public function get_userid_by_name($name)
    {
        $this->db->select('id');
            $this->db->from('user');
            $this->db->where('first_name',$name);
            $result= $this->db->get()->result_array();  
             return $result;

    }
        public function get_all_users()
    {
        $this->db->select('.*,count(*) as count');
        $this->db->from('user');
        //$this->db->where('active',1);
        $result= $this->db->get()->result();  
        $result =json_decode( json_encode($result, true));  
        return json_decode( json_encode($result, true));
    }
    public function get_all_users_citywise($where=""){
        $this->db->select()
            ->from('user')
            ->order_by('first_name','asc')
            ->order_by('last_name','asc');
            $this->db->where('active',1);
            $this->db->where('city_id',$this->session->userdata('user_city_id')); 
            $this->db->where('city_id',$this->session->userdata('user_city_id')); 
        $query=$this->db->get();
        return $query->result();
    }

    public function get_active_users_count($value='')
    {
        $date = date("Y-m-d H:i:s", strtotime(date('Y-m-d H:i:s')) - 20);
        $this->db->select('count(*) as count')
        ->from('user')
        ->where('last_update>=',$date)
        ->where('active',1);

        $result= $this->db->get()->result();  
        //$result =json_decode( json_encode($result, true));  
        return json_decode(json_encode($result, true));
    }
    public function get_user_device_token($id=null)
    {
       $this->db->select('device_token')
            ->from('user_device_info')
            ->order_by('id','desc') 
            ->where('user_id',$id)
            ->limit(1); 
        $query=$this->db->get();
        return $query->result();
    } 
    public function get_user_location($data='')
    { 
        $this->db->select('u1.latitude latitude , u1.longitude longitude, concat(u2.first_name," ",u2.last_name) as user_name, u1.date_added as date_created')
        ->from('user_tracker as u1')
        ->join('user as u2','u2.id=u1.user_id','LEFT')
        ->where($data); 
        $result= $this->db->get()->result();    
        return $result;
    }
    


}